/*****************************************************************************
 * Copyright (C) 2000 Jim Kent.  This source code may be freely used         *
 * for personal, academic, and non-profit purposes.  Commercial use          *
 * permitted only by explicit agreement with Jim Kent (jim_kent@pacbell.net) *
 *****************************************************************************/
/* portable.h - wrappers around things that vary from server
 * to server and operating system to operating system. */

#include <sys/types.h>
#include <sys/stat.h>

/* The size of a file. */
long fileSize(char *fileName);

/* Does a file exist? */
boolean fileExists(char *fileName);

/* Return an alphabetized list of all files that match 
 * the wildcard pattern in directory. */
struct slName *listDir(char *dir, char *pattern);

/* Return current directory. */
char *getCurrentDir();

/* Set current directory.  Return FALSE if it fails. */
boolean setCurrentDir(char *newDir);

/* 1000 hz clock */
long clock1000();

/* This structure helps us generate temp names and use
 * them.  Since different servers locate where the cgi
 * runs from differently, and where the generated html
 * file runs from - this is necessary for portable code. */
struct tempName
	{
	char forCgi[128];
	char forHtml[128];
	};

/* Make a good name for a temp file. */
void makeTempName(struct tempName *tn, char *base, char *suffix);

/* Return directory to look for cgi in. */
char *cgiDir();

/* Return cgi suffix. */
char *cgiSuffix();

/* Return relative speed of machine.  UCSC CSE dept. 1999 web server is 1.0 */
double machineSpeed();

/* Return host computer on network for mySQL database. */
char *mysqlHost();

/* Invoke the debugger. */
void uglyfBreak();

